package net.knarcraft.bookswithoutborders.command;

import net.knarcraft.bookswithoutborders.BooksWithoutBorders;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

/**
 * Command executor for the delete command
 */
public class CommandDelete implements CommandExecutor {

    private final BooksWithoutBorders booksWithoutBorders;

    public CommandDelete(BooksWithoutBorders booksWithoutBorders) {
        this.booksWithoutBorders = booksWithoutBorders;
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (!(sender instanceof Player player)) {
            BooksWithoutBorders.sendErrorMessage(sender, "This command can only be used by a player!");
            return false;
        }

        //List deletable files
        if (args.length == 0) {
            BooksWithoutBorders.loadList.put(player.getName(), booksWithoutBorders.listFiles(player, false, false));
            return true;
        }
        //Delete the file
        if (args.length == 1) {
            if (!BooksWithoutBorders.loadList.containsKey(player.getName())) {
                BooksWithoutBorders.sendErrorMessage(player, "You must first use /bwb delete to create a list of delete-able files!");
                return false;
            } else {
                if (!BooksWithoutBorders.loadList.get(player.getName()).isEmpty()) {
                    booksWithoutBorders.deleteBook(player, args[0], false);
                    return true;
                } else {
                    BooksWithoutBorders.sendErrorMessage(player, "No files available to delete!");
                    return false;
                }
            }
        }
        BooksWithoutBorders.sendErrorMessage(player, "Incorrect number of arguments for this command!");
        return false;
    }

}
