package net.knarcraft.bookswithoutborders.command;

import net.knarcraft.bookswithoutborders.BooksWithoutBorders;
import net.knarcraft.bookswithoutborders.state.ItemSlot;
import net.knarcraft.bookswithoutborders.utility.InventoryHelper;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

/**
 * Command executor for the un-sign command
 */
public class CommandUnSign implements CommandExecutor {

    private final BooksWithoutBorders booksWithoutBorders;

    public CommandUnSign(BooksWithoutBorders booksWithoutBorders) {
        this.booksWithoutBorders = booksWithoutBorders;
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (!(sender instanceof Player player)) {
            BooksWithoutBorders.sendErrorMessage(sender, "This command can only be used by a player!");
            return false;
        }

        if (InventoryHelper.notHoldingOneWrittenBookCheck(player, "You must be holding a signed book to un-sign it!",
                "You cannot un-sign two books at once. Please un-equip one of the books you're holding!")) {
            return false;
        }

        //Find which hand the player is using to hold the book. If holding one in each, throw an error
        ItemSlot holdingSlot = InventoryHelper.getHeldSlotBook(player, false, false, true, true);
        booksWithoutBorders.unSignHeldBook(player, holdingSlot == ItemSlot.MAIN_HAND);
        return true;
    }
}
